牛客练习赛40 C-小A与欧拉路(树形dp | 两次dfs 求树的直径)
原创
©著作权归作者所有:来自51CTO博客作者wx5e9d3f1cab2eb的原创作品,请联系作者获取转载授权,否则将追究法律责任
C-小A与欧拉路
题意:求图中最短的欧拉路。
题解:因为是一棵树,因此当从某一个节点遍历其子树的时候,如果还没有遍历完整个树,一定还需要再回到这个节点再去遍历其它子树,因此除了从起点到终点之间的路,其它路都被走了两次,而我们要求总的路程最短,那么我们就让从起点到终点的路最长即可,也就是树的直径。所以答案就是所有边权的两倍再减去树的直径。
代码
#include<bits/stdc++.h>
#define DEBUG(x) std::cerr << #x << '=' << x << std::endl
#define P pair<int,LL>
typedef long long LL;
using namespace std;
const int N = 2E5+10;
LL d[N];
vector<P> E[N];
void dfs(int u,int fa)
{
for(auto &it : E[u]) {
int v = it.first;
LL w = it.second;
if(fa == v) continue;
d[v] = d[u] + w;
dfs(v,u);
}
}
int main()
{
#ifndef ONLINE_JUDGE
freopen("input.in","r",stdin);
#endif
ios::sync_with_stdio(false);
cin.tie(0);
int n, u, v, w;
LL sum = 0;
cin >> n;
for(int i = 0; i < n - 1; ++i) {
cin >> u >> v >> w;
E[u].push_back(P(v,w));
E[v].push_back(P(u,w));
sum += 2 * w;
}
dfs(1,0);
int rt = 1;
for(int i = 1; i <= n; ++i) {
if(d[rt] < d[i]) rt = i;
DEBUG(d[i]);
}
d[rt] = 0;
dfs(rt,0);
cout << sum - *max_element(d + 1,d + n + 1) << endl;
return 0;
}
#include<bits/stdc++.h>
#define DEBUG(x) std::cerr << #x << '=' << x << std::endl
#define P pair<int,int>
using namespace std;
const int N = 2E5+10;
typedef long long LL;
LL dp[N][2], maxL;
vector<P> E[N];
void dfs(int u,int fa)
{
for(auto &it : E[u]) {
int v = it.first;
int w = it.second;
if(fa == v) continue;
dfs(v,u);
if(dp[v][0] + w > dp[u][0]) { //如果以u为根节点的最长链可以被它的儿子v更新
dp[u][1] = dp[u][0]; //那么此时以u为根节点的次长链变为dp[u][0];
dp[u][0] = dp[v][0] + w; //最长链被更新
}else if(dp[v][0] + w > dp[u][1]) { //如果不能更新最长链但是却可以更新次长链
dp[u][1] = dp[v][0] + w;
}
}
maxL = max(maxL,dp[u][1] + dp[u][0]);
}
int main()
{
#ifndef ONLINE_JUDGE
freopen("input.in","r",stdin);
#endif
ios::sync_with_stdio(false);
cin.tie(0);
int n,u,v,w;
LL sum = 0;
cin >> n;
for(int i = 0; i < n - 1; ++i) {
cin >> u >> v >> w;
E[u].push_back(P(v,w));
E[v].push_back(P(u,w));
sum += 2 * w;
}
dfs(1,0);
cout << sum - maxL << endl;
return 0;
}